SystemOrganization addCategory: #'Pier-TagCloud'!

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:21'!
descriptionMenuTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:21'!
descriptionNameTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:20'!
descriptionTagsTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 9/13/2007 10:20'!
descriptionTitleTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRStructure methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:09'!
tagsUsing: aCollection
	"Answer a list of tags using the given aCollection of descriptions."
	
	^ aCollection
		inject: OrderedCollection new
		into: [ :collection :each |
			collection addAll: ((each toString: (self readUsing: each))
				findTokens: ' ').
			collection ]! !

PRWidget subclass: #PRTagCloudWidget
	instanceVariableNames: 'tags tagsByCount tagsByName focus mean deviation'
	classVariableNames: 'StopWords'
	poolDictionaries: ''
	category: 'Pier-TagCloud'!

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionDataDescriptions
	| optionsAndLabels |
	optionsAndLabels := Dictionary new.
	PRStructure withAllSubclassesDo: 
		[ :class | 
		class description do: 
			[ :each | 
			each isTagCloud ifTrue: 
				[ optionsAndLabels 
					at: each
					put: each label ] ] ].
	^ MAMultipleOptionDescription new
		optionsAndLabels: optionsAndLabels associations;
		reference: MADescription description;
		accessor: #dataDescriptions;
		default: optionsAndLabels keys;
		priority: 220;
		label: 'Data';
		beDistinct;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionIgnoredTags
	^ MAMemoDescription new
		accessor: #ignoredTags;
		label: 'Ignored tags';
		priority: 220;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionMaxItems
	^ MANumberDescription new
		accessor: #maxItems;
		label: 'Max Items';
		priority: 220;
		default: 50;
		beInteger;
		min: 1;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 2/23/2010 20:46'!
descriptionShowExponential
	^ MABooleanDescription new
		checkboxLabel: 'Exponential';
		accessor: #showExponential;
		default: false;
		priority: 235;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionShowFrequencies
	^ MABooleanDescription new
		accessor: #showFrequencies;
		checkboxLabel: 'Frequencies';
		default: false;
		label: 'Show';
		priority: 230;
		yourself! !

!PRTagCloudWidget class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionStructure
	^ PRStructureDescription new
		accessor: #startAt;
		label: 'Start At';
		priority: 200;
		yourself! !

!PRTagCloudWidget class methodsFor: 'initialization' stamp: 'lr 9/14/2007 13:39'!
initialize
	StopWords := Set withAll: #('--' '---' 'about' 'an' 'and' 'are' 'as' 'at' 'be' 'by' 'com' 'de' 'en' 'for' 'from' 'he' 'her' 'hers' 'herself' 'him' 'himself' 'how' 'in' 'is' 'it' 'its' 'itself' 'la' 'me' 'mine' 'my' 'myself' 'of' 'on' 'oneself' 'or' 'our' 'ours' 'ourselves' 'she' 'that' 'the' 'their' 'theirs' 'them' 'themselves' 'these' 'they' 'this' 'those' 'to' 'und' 'us' 'was' 'we' 'what' 'when' 'where' 'who' 'will' 'with' 'www' 'you' 'your' 'yours' 'yourself' 'yourselves')! !

!PRTagCloudWidget class methodsFor: 'testing' stamp: 'lr 9/12/2007 22:55'!
isAbstract
	^ false! !

!PRTagCloudWidget class methodsFor: 'accessing' stamp: 'lr 9/12/2007 22:54'!
label
	^ 'Tag Cloud'! !

!PRTagCloudWidget methodsFor: 'private' stamp: 'lr 2/23/2010 20:40'!
computeParameters
	| count |
	count := self tagsByCount size max: 1.
	mean := 0.0.
	deviation := 0.0.
	self tagsByCount do: [ :each | mean := mean + each value size ].
	mean := mean / count.
	self tagsByCount do: [ :each | deviation := deviation + (mean - each value size) abs ].
	deviation := deviation / count.
	deviation = 0.0 ifTrue: [ deviation := 1.0 ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 2/23/2010 20:40'!
deviation
	deviation isNil
		ifTrue: [ self computeParameters ].
	^ deviation! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/12/2007 22:32'!
enumerator
	"Answer an enumerator to visit the necessary structures to collect the tags."
	
	^ (self context enumeratorFor: self structure) with all! !

!PRTagCloudWidget methodsFor: 'actions' stamp: 'lr 9/14/2007 17:56'!
focus: anAssocation
	focus := anAssocation! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'tg 11/17/2007 00:40'!
ignoredTags
	^(self read: #descriptionIgnoredTags) ifNil: ['']! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 2/23/2010 20:40'!
mean
	mean isNil
		ifTrue: [ self computeParameters ].
	^ mean! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 9/14/2007 19:01'!
renderCloudOn: html
	self tagsByName 
		do: [ :assoc | self renderTag: assoc on: html ]
		separatedBy: [ html text: ' ' ]! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 9/14/2007 17:57'!
renderContentOn: html
	focus isNil
		ifTrue: [ self renderCloudOn: html ]
		ifFalse: [ self renderFocusOn: html ]! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 9/17/2007 08:40'!
renderFocusOn: html
	| structures related |
	structures := focus value asSet
		asSortedCollection: [ :a :b | a title < b title ].
	html heading level: 1; with: [ 
		html anchor
			callback: [ focus := nil ];
			with: focus key ].
	html definitionList: [
		structures do: [ :each |
			html definitionTerm: [
				html anchor
					callback: [ 
						self context: (self context structure: each).
						focus := nil ];
					with: each title ].
			html definitionData: [
				related := self tagsByCount
					select: [ :assoc | assoc key ~= focus key and: [ assoc value includes: each ] ].
				((related last: (5 min: related size))
					asSortedCollection: [ :a :b | a key < b key ])
					do: [ :assoc | self renderTag: assoc on: html ]
					separatedBy: [ html text: ' ' ] ] ] ]! !

!PRTagCloudWidget methodsFor: 'rendering' stamp: 'lr 2/23/2010 20:48'!
renderTag: anAssociation on: html
	| diff percent |
	(self read: #descriptionShowExponential)
		ifTrue: [
			| min max |
			min := self tagsByCount first value size.
			max := self tagsByCount last value size.
			(diff := max - min) isZero
				ifTrue: [ diff := 1 ].
			percent := ((anAssociation value size - min) * 100.0 / diff) + 100 ]
		ifFalse: [
			diff := ((anAssociation value size - self mean) / self deviation) exp.
			percent := ((diff - 1) / (diff + 1) * (1.8 ln)) exp * 100.0 ].
	html span class: 'tag'; with: [
		html anchor
			callback: [ self focus: anAssociation ];
			style: 'font-size: ' , percent truncated asString , '%';
			with: anAssociation key.
		(self read: #descriptionShowFrequencies) ifTrue: [
			html span
				class: 'freq';
				with: [ html space; text: '('; render: anAssociation value size; text: ')' ] ] ]! !

!PRTagCloudWidget methodsFor: 'actions' stamp: 'lr 2/23/2010 20:39'!
reset
	tags := tagsByName := tagsByCount := focus := mean := deviation := nil! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 2/23/2010 20:38'!
structure
	"Answer the structure where the search for the tag cloud should start from."
	
	^ (self read: #descriptionStructure) ifNil: [ self context root ]! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'tg 11/19/2007 17:49'!
tags
	"Answer a dictionary mapping tags to structures."
	
	tags isNil
		ifFalse: [ ^ tags ].
	tags := Dictionary new.
	self enumerator do: [ :struct |
		(self read: #descriptionDataDescriptions) do: [ :description |
			(self tokenize: struct using: description) do: [ :tag |
				(tags at: tag ifAbsentPut: [ OrderedCollection new ])
					add: struct ] ] ].
	^ tags! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/14/2007 17:53'!
tagsByCount
	"Answer a dictionary mapping tags to structures. The tags are sorted by count and cut to a certain threshold."
	
	tagsByCount isNil
		ifFalse: [ ^ tagsByCount ].
	tagsByCount := SortedCollection
		sortBlock: [ :a :b | a value size < b value size ].
	self tags associationsDo: [ :assoc | tagsByCount add: assoc ].
	(self read: #descriptionMaxItems) isNil
		ifFalse: [ tagsByCount := tagsByCount last: (tagsByCount size min: (self read: #descriptionMaxItems)) ].
	^ tagsByCount! !

!PRTagCloudWidget methodsFor: 'accessing' stamp: 'lr 9/14/2007 18:05'!
tagsByName
	"Answer the tags alphabetically sorted by name."
	
	tagsByName isNil
		ifFalse: [ ^ tagsByName ].
	^ tagsByName := self tagsByCount 
		asSortedCollection: [ :a :b | a key < b key ]! !

!PRTagCloudWidget methodsFor: 'private' stamp: 'tg 11/17/2007 00:32'!
tokenize: anObject using: aDescription
	| string tokens ignoredTokens |
	(aDescription accessor canRead: anObject)
		ifFalse: [ ^ #() ].
	string := aDescription toString: (anObject readUsing: aDescription).
	string := string collect: [ :each | 
		each isLetter
			ifTrue: [ each asLowercase ]
			ifFalse: [ 
				each = $-
					ifTrue: [ each ]
					ifFalse: [ $  ] ] ].
	tokens := string findTokens: ' '.
	ignoredTokens := self ignoredTags findTokens: ' '.
	^ tokens reject: [ :each | each size = 1 or: [ (StopWords includes: each) or: [ignoredTokens includes: each] ] ]
! !

!GRPackage class methodsFor: '*pier-tagcloud' stamp: 'lr 2/18/2010 11:55'!
pierTagCloud
	^ self new
		name: 'Pier-TagCloud';
		description: 'A tag cloud for Pier.';
		addDependency: 'Pier-Model';
		addDependency: 'Pier-Seaside';
		url: #pierUrl;
		yourself! !

!MADescription methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:22'!
beTagCloud
	self propertyAt: #tagCloud put: true! !

!MADescription methodsFor: '*pier-tagcloud' stamp: 'lr 9/13/2007 10:22'!
isTagCloud
	^ self propertyAt: #tagCloud ifAbsent: [ false ]! !

!PRCase class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 2/23/2010 20:26'!
descriptionDocumentTagCloud: aDescription
	^ aDescription beTagCloud! !

!PRCase class methodsFor: '*pier-tagcloud-descriptions' stamp: 'lr 2/23/2010 20:23'!
descriptionPlainTextTagCloud: aDescription
	^ aDescription beTagCloud! !
PRTagCloudWidget initialize!
